<? /*
 * phpHartPOP - A simple web interface to a POP3 mailbox
 * Copyright (C) 2003 Sebastian Pipping
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * Sebastian Pipping <webmaster@hartwork.org>
 */

include( "config.php" );
include( "shared.gen.inc.php" );
include( "shared.mime.inc.php" );
include( "shared.pop3.inc.php" );

prevent_caching();

// Ensure we get the time we need
set_time_limit( 0 );

// Move [$_GET] into [$_POST]
foreach( $_GET as $key => $val )
{
	$_POST[ $key ] = $val;
}
unset( $_GET );

session_start();

// Get account data
$account_error = false;
if( USE_LOGIN_MODE )
{
	$account_id = $_POST[ "account" ];
	if( $account_id != "" )
	{
		// Read account from session
		$account_host = $_SESSION[ $account_id . "host" ];
		$account_port = $_SESSION[ $account_id . "port" ];
		$account_user = $_SESSION[ $account_id . "user" ];
		$account_pass = $_SESSION[ $account_id . "pass" ];
	}
	else
	{
		// Read account from [$_POST]
		if( $_POST[ "new_account" ] != "1" )
		{
			$account_error = true;
		}
		else
		{
			// ID
			if( empty( $_SESSION[ "accounts" ] ) )
			{
				$account_id = 1;
			}
			else
			{
				$account_id = $_SESSION[ "accounts" ] + 1;
			}

			// Host
			$account_host = $_POST[ "host" ];
			if( $account_host == "" )
			{
				$account_error = true;
			}
			else
			{
				$matches = array();
				if( preg_match( "/([^:]+):(\d+)/", $account_host, $matches ) )
				{
					$account_host = $matches[ 1 ];
					$account_port = $matches[ 2 ];
				}
				else
				{
					$account_port = 110;
				}

				// User
				$account_user = $_POST[ "user" ];
				if( $account_user == "" )
				{
					$account_error = true;
				}
				else
				{
					// Pass
					$account_pass = $_POST[ "pass" ];
					if( $account_pass == "" )
					{
						$account_error = true;
					}
					else
					{
						// Everything fine -> save for session
						$_SESSION[ "accounts" ]++;
						$_SESSION[ $account_id . "host" ] = $account_host;
						$_SESSION[ $account_id . "port" ] = $account_port;
						$_SESSION[ $account_id . "user" ] = $account_user;
						$_SESSION[ $account_id . "pass" ] = $account_pass;
					}
				}
			}
		}
	}
}
else
{
	$account_host = ACCOUNT_HOST;
	if( $account_host == "" )
	{
		$account_error = true;
	}
	else
	{
		$account_port = ACCOUNT_PORT;
		if( $account_port == "" )
		{
			$account_error = true;
		}
		else
		{
			$account_user = ACCOUNT_USER;
			if( $account_user == "" )
			{
				$account_error = true;
			}
			else
			{
				$account_pass = ACCOUNT_PASS;
				if( $account_pass == "" )
				{
					$account_error = true;
				}
			}
		}
	}
}

if( $account_error )
{
	if( USE_LOGIN_MODE )
	{
		// Login once again
		header( "Location: index.php" );
		exit;
	}
}

?>
<HTML><!-- Copyright  2003 Sebastian Pipping <webmaster@hartwork.org> -->
<HEAD>
<LINK REL="stylesheet" HREF="style.css">
</HEAD>

<SCRIPT LANGUAGE="JavaScript">

function resolve_mail( address )
{
	if( address != "" )
	{
		window.location.href = "mailto:" + address;
	}
}

</SCRIPT>

<BODY LEFTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0">

<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" WIDTH="100%" HEIGHT="100%"><!--(1)-->
	<TR>
		<TD ALIGN="center">
			<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" HEIGHT="100%" WIDTH="10"><!--(2) explode-->
				<TR>
					<TD BGCOLOR="#E0E0E0" WIDTH="1" HEIGHT="100%"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="100%"></TD>
					<TD VALIGN="top" HEIGHT="100%">
						<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" WIDTH="10" HEIGHT="100%"><!--(3) content-->
							<TR HEIGHT="100"><!--(3)(1)-->
								<TD ALIGN="center" VALIGN="center">
									<SPAN STYLE="font-size:22pt"><B>phpHartPOP</B></SPAN><BR>
									Give your pop a face
								</TD>
							</TR>
							<TR HEIGHT="10"><!--(3)(2) explode-->
								<TD BGCOLOR="#EFEFEF" VALIGN="top" WIDTH="100%" STYLE="padding-top:4px;padding-bottom:4px"><!-- status -->
<?

// Connect
$login_error = $account_error;
if( !$login_error )
{

	$socket = @fsockopen( $account_host, $account_port, $errno, $errstr, CONNECTION_TIMEOUT );
	if( !$socket )
	{
		echo "&nbsp;&nbsp;ERROR: Could not connect to [$account_host] on port [$account_port]<BR>\n";
		$login_error = true;
	}
	else
	{
		register_shutdown_function( "pop3_disconnect" );
		$line = get_answer();
		if( !pop3_success( $line ) )
		{
			echo "&nbsp;&nbsp;ERROR: \"" . rtrim( substr( $line, 5 ) ) . "\"<BR>\n";
			$login_error = true;
		}
		else
		{
			// USER
			fputs( $socket, "USER " . $account_user . "\015\012" );
			$line = get_answer();
			if( !pop3_success( $line ) )
			{
				echo "&nbsp;&nbsp;ERROR with command USER: \"" . rtrim( substr( $line, 5 ) ) . "\"<BR>\n";
				$login_error = true;
			}
			else
			{
				// PASS
				fputs( $socket, "PASS " . $account_pass . "\015\012" );
				$line = get_answer();
				if( !pop3_success( $line ) )
				{
					echo "&nbsp;&nbsp;ERROR with command PASS: \"" . rtrim( substr( $line, 5 ) ) . "\"<BR>\n";
					$login_error = true;
				}
				else
				{
					// LIST
					fputs( $socket, "LIST\015\012" );
					$matches = array();
					$mails = array();
					$number_of_mails = 0;
					while( TRUE )
					{
						$line = get_answer();
						if( preg_match( "/^(\d+) (\d+)/", $line, $matches ) )
						{
							$mails[ ++$number_of_mails ] = array();
							$mails[ $number_of_mails ][ "index" ] = $matches[ 1 ];
							$mails[ $number_of_mails ][ "size" ] = $matches[ 2 ];
						}
						if( substr( $line, 0, 1 ) == "." )
						{
							break;
						}
					}

					// Delete messages
					$i = 1;
					$total_deleted = 0;
					while( $i <= $number_of_mails )
					{
						if( isset( $_POST[ "del" . $mails[ $i ][ "index" ] ] ) )
						{
							// Same size?
							if( ( $mails[ $i ][ "size" ] != $_POST[ "siz" . $mails[ $i ][ "index" ] ] ) && ( $mails[ $i ][ "size" ] - $_POST[ "siz" . $mails[ $i ][ "index" ] ] != 11 ) )
							{
								echo "&nbsp;&nbsp;ERROR: Message " . $mails[ $i ][ "index" ] . " has wrong size<BR>\n";
								$i++;
								continue;
							}

							// Delete
							fputs( $socket, "DELE " . $mails[ $i ][ "index" ] . "\015\012" );
							$line = get_answer();
							if( !pop3_success( $line ) )
							{
								echo "&nbsp;&nbsp;ERROR: \"" . $line . "\"<BR>\n";
								$i++;
								continue;
							}
							else
							{
								// Kick and close the gap
								for( $j = $i; $j < $number_of_mails ; $j++ )
								{
									$mails[ $j ] = $mails[ ($j + 1) ];
								}
								array_pop( $mails );
								$number_of_mails--;
							}
							$total_deleted++;
						}
						else
						{
							$i++;
						}
					}
				}
			}
		}
	}
}

if( !$login_error )
{
	if( $total_deleted )
	{
		echo "&nbsp;&nbsp;" . $total_deleted . " message" . ( ( $total_deleted != 1 ) ? "s" : "" ) . " successfully deleted<BR>\n";
	}

	$space_sum = 0;
	foreach( $mails as $entry )
	{
		$space_sum += $entry[ "size" ];
	}
	echo "&nbsp;&nbsp;Mailbox contains " . $number_of_mails . " message" . plural( $number_of_mails ) . " (" . $space_sum . " byte" . plural( $space_sum ) . ")<BR>\n";
}
else
{
	if( $account_error )
	{
		echo "&nbsp;&nbsp;ERROR: Please edit your account in [config.php]<BR>\n";
	}
}

?>
								</TD>
							</TR>
							<TR HEIGHT="*"><!--(3)(3) mails explode-->
								<TD VALIGN="top">
									<FORM NAME="MAILS" ACTION="<? echo basename( $_ENV[ "PATH_INFO" ] ); ?>" METHOD="POST">
										<INPUT TYPE="hidden" NAME="account" VALUE="<? echo $account_id; ?>">
										<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" STYLE="margin-top:20px"><!--(4.1)-->
											<TR>
												<TD COLSPAN="8" BGCOLOR="#E0E0E0" HEIGHT="1"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="1"></TD>
											</TR>
											<TR>
												<TD COLSPAN="6" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
												<TD WIDTH="2" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="2" HEIGHT="2"></TD>
												<TD HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
											</TR>
											<TR>
												<TD>&nbsp;</TD>
												<TD>&nbsp;</TD>
												<TD WIDTH="200"><NOBR>&nbsp;&nbsp;<B>FROM</B>&nbsp;&nbsp;</NOBR></TD>
												<TD WIDTH="250"><NOBR>&nbsp;&nbsp;<B>SUBJECT</B>&nbsp;&nbsp;</NOBR></TD>
												<TD ALIGN="center"><NOBR>&nbsp;&nbsp;<B>DATE</B>&nbsp;&nbsp;</NOBR></TD>
												<TD>&nbsp;</TD>
												<TD WIDTH="2" HEIGHT="100%"><IMG SRC="pixel.gif" BORDER="0" WIDTH="2" HEIGHT="100%"></TD>
												<TD ALIGN="center"><NOBR>&nbsp;&nbsp;<B>ACTIONS</B>&nbsp;&nbsp;</NOBR></TD>
											</TR>
											<TR>
												<TD COLSPAN="6" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
												<TD WIDTH="2" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="2" HEIGHT="2"></TD>
												<TD HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
											</TR>
<?

if( !$number_of_mails )
{
	?>
											<TR>
												<TD COLSPAN="8" BGCOLOR="#E0E0E0" HEIGHT="1"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="1"></TD>
											</TR>
											<TR>
												<TD COLSPAN="6" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
												<TD BGCOLOR="#E0E0E0" WIDTH="2" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="2" HEIGHT="2"></TD>															<TD HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
											</TR>
											<TR>
												<TD VALIGN="center"><NOBR>&nbsp;<INPUT TYPE="checkbox" NAME="del0" VALUE="1">&nbsp;</TD>
												<TD ALIGN="right" VALIGN="center">0000&nbsp;&nbsp;</NOBR></TD>
												<TD VALIGN="center"><NOBR>&nbsp;&nbsp;<U>Nobody</U>&nbsp;&nbsp;</NOBR></TD>
												<TD VALIGN="center"><NOBR>&nbsp;&nbsp;No subject&nbsp;&nbsp;</NOBR></TD>
												<TD VALIGN="center"><NOBR>&nbsp;&nbsp;0000-00-00 00:00:00&nbsp;&nbsp;</NOBR></TD>
												<TD ALIGN="right" VALIGN="center"><NOBR>&nbsp;&nbsp;0&nbsp;&nbsp;&nbsp;&nbsp;</NOBR></TD>
												<TD VALIGN="center" BGCOLOR="#E0E0E0" WIDTH="2" HEIGHT="100%"><IMG SRC="pixel.gif" BORDER="0" WIDTH="2" HEIGHT="100%"></TD>
												<TD VALIGN="center"><NOBR>&nbsp;&nbsp;&nbsp;&nbsp;<U CLASS="gray">View</U> <U CLASS="gray">Download</U> <U CLASS="gray">Delete</U>&nbsp;&nbsp;&nbsp;&nbsp;</NOBR></TD>
											</TR>
											<TR>
												<TD COLSPAN="6" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
												<TD BGCOLOR="#E0E0E0" WIDTH="2" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="2" HEIGHT="2"></TD>
												<TD HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
											</TR>
	<?

}
else
{
	for( $i = $number_of_mails; $i; $i-- )
	{
		pop3_top( $mails[ $i ][ "index" ], $headers );
		get_subject( $headers, $subject );
		get_from( $headers, $from_name, $from_addy );
		get_date( $headers, $date );

		?>
											<TR>
												<TD COLSPAN="8" BGCOLOR="#E0E0E0" HEIGHT="1"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="1"></TD>
											</TR>
											<TR>
												<TD COLSPAN="6" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
												<TD BGCOLOR="#E0E0E0" WIDTH="2" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="2" HEIGHT="2"></TD>															<TD HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
											</TR>
											<TR>
												<TD VALIGN="center"><NOBR>&nbsp;<INPUT TYPE="hidden" NAME="siz<? echo $i; ?>" VALUE="<? echo $mails[ $i ][ "size" ]; ?>"><INPUT TYPE="checkbox" NAME="del<? echo $mails[ $i ][ "index" ]; ?>" VALUE="1">&nbsp;</TD>
												<TD ALIGN="right" VALIGN="center"><? printf( "%04u", $i ); ?>&nbsp;&nbsp;</NOBR></TD>
												<TD VALIGN="center"><NOBR>&nbsp;&nbsp;<A HREF="javascript:resolve_mail('<? echo cripple_js( $from_addy ); ?>')"><? echo cripple_html( $from_name ); ?></A>&nbsp;&nbsp;</NOBR></TD>
												<TD VALIGN="center"><NOBR>&nbsp;&nbsp;<? echo $subject; ?>&nbsp;&nbsp;</NOBR></TD>
												<TD VALIGN="center"><NOBR>&nbsp;&nbsp;<? echo $date; ?>&nbsp;&nbsp;</NOBR></TD>
												<TD ALIGN="right" VALIGN="center"><NOBR>&nbsp;&nbsp;<? echo $mails[ $i ][ "size" ]; ?>&nbsp;&nbsp;&nbsp;&nbsp;</NOBR></TD>
												<TD VALIGN="center" BGCOLOR="#E0E0E0" WIDTH="2" HEIGHT="100%"><IMG SRC="pixel.gif" BORDER="0" WIDTH="2" HEIGHT="100%"></TD>
												<TD VALIGN="center"><NOBR>&nbsp;&nbsp;&nbsp;&nbsp;<A HREF="view.php?account=<? echo $account_id; ?>&index=<? echo $i; ?>&action=view" TARGET="_blank" CLASS="red">View</A> <A HREF="view.php?account=<? echo $account_id; ?>&index=<? echo $i; ?>&action=download" CLASS="red">Download</A> <A HREF="mailbox.php?account=<? echo $account_id; ?>&del<? echo $i; ?>=1&siz<? echo $i; ?>=<? echo $mails[ $i ][ "size" ]; ?>" CLASS="red">Delete</A>&nbsp;&nbsp;&nbsp;&nbsp;</NOBR></TD>
											</TR>
											<TR>
												<TD COLSPAN="6" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
												<TD BGCOLOR="#E0E0E0" WIDTH="2" HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="2" HEIGHT="2"></TD>
												<TD HEIGHT="2"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="2"></TD>
											</TR>
	<?

	}
}

?>
											<TR>
												<TD COLSPAN="8" BGCOLOR="#E0E0E0" HEIGHT="1"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="1"></TD>
											</TR>
											<TR>
												<TD>&nbsp;</TD>
												<TD COLSPAN="7" STYLE="padding-top:20px; padding-bottom:0px">
<?
	if( $number_of_mails )
	{
		?>
													<A HREF="javascript:select_all(true)">Select all</A>&nbsp;
													<A HREF="javascript:select_all(false)">Select none</A>&nbsp;
													<A HREF="javascript:select_invert()">Invert selection</A>
													<BR>
													<BR>
													<BR>
													<SPAN CLASS="red">-&gt;&nbsp;</SPAN><A HREF="javascript:document.forms['MAILS'].submit()" CLASS="red">Delete selected messages</A><BR>
		<?
	}
	else
	{
		?>
													<U CLASS="gray">Select all</U>&nbsp;
													<U CLASS="gray">Select none</U>&nbsp;
													<U CLASS="gray">Invert selection</U>&nbsp;
													<BR>
													<BR>
													<BR>
													<SPAN CLASS="gray">-&gt;&nbsp;<U>Delete selected messages</U></SPAN><BR>
		<?
	}
?>
													<BR>
													-&gt;&nbsp;<A HREF="javascript:location.reload()">Re-read mailbox</A><BR>
													-&gt;&nbsp;<A HREF="index.php">Change mailbox</A>
												</TD>
											</TR>
										</TABLE><!--(4.1)-->
									</FORM>
								</TD>
							</TR>
							<TR HEIGHT="10">
								<TD VALIGN="bottom">
									<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" WIDTH="100%"><!--(4.2)-->
										<TR HEIGHT="28">
											<TD COLSPAN="2" HEIGHT="28"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="28"></TD>
										</TR>
										<TR HEIGHT="1">
											<TD COLSPAN="2" BGCOLOR="#E0E0E0" HEIGHT="1"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="1"></TD>
										</TR>
										<TR>
											<TD CLASS="gray">
												<NOBR>Copyright &copy; 2003 Sebastian Pipping &lt;<A HREF="javascript:resolve_mail('<? echo cripple_js( "webmaster@hartwork.org" ); ?>')" CLASS="copyright"><? echo cripple_html( "webmaster@hartwork.org" ); ?></A>&gt;</NOBR>
											</TD>
											<TD ALIGN="right" CLASS="gray">
												<NOBR>&nbsp;&nbsp;phpHartPOP <? echo PHPHARTPOP_VERSION; ?></NOBR>
											</TD>
										</TR>
										<TR HEIGHT="16">
											<TD COLSPAN="2" HEIGHT="16"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="16"></TD>
										</TR>
									</TABLE><!--(4.2)-->
								</TD>
							</TR>
						</TABLE><!--(3)-->
					</TD><!-- content -->
					<TD BGCOLOR="#E0E0E0" WIDTH="1" HEIGHT="100%"><IMG SRC="pixel.gif" BORDER="0" WIDTH="1" HEIGHT="100%"></TD>
				</TR>
			</TABLE><!--(2)-->
		</TD>
	</TR>
</TABLE><!--(1)-->

<SCRIPT LANGUAGE="JavaScript">

function select_all( status )
{
	for( i = 1; i <= <? echo $number_of_mails; ?>; i++ )
	{
		document.forms['MAILS'].elements[ i * 2 ].checked = status;
	}
}

function select_invert()
{
	var e = 0;
	for( var i = 1; i <= <? echo $number_of_mails; ?>; i++ )
	{
		e = i * 2;
		document.forms['MAILS'].elements[ e ].checked = !document.forms['MAILS'].elements[ e ].checked;
	}
}

</SCRIPT>

</BODY>
</HTML>