<? /*
 * phpHartPOP - A simple web interface to a POP3 mailbox
 * Copyright (C) 2003 Sebastian Pipping
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * Sebastian Pipping <webmaster@hartwork.org>
 */

// --------------------------------------------------------------------------------------------------prevent_caching-----
function prevent_caching()
{
	header( "Expires: Mon, 26 Jul 1997 05:00:00 GMT" );    				// Date in the past
	header( "Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT" );	// always modified
	header( "Cache-Control: no-store, no-cache, must-revalidate" );		// HTTP/1.1
	header( "Cache-Control: post-check=0, pre-check=0", false );
	header( "Pragma: no-cache");                          				// HTTP/1.0
}

// -----------------------------------------------------------------------------------------------------------plural-----
function plural( $number )
{
	return ( ( $number != 1 ) ? "s" : "" );
}

// ---------------------------------------------------------------------------------------------------valid_filename-----
function valid_filename( $filename )
{
/*
	$filename = str_replace( "\\", "_", $filename );
	$filename = str_replace( "/",  "_", $filename );
	$filename = str_replace( ":",  "_", $filename );
	$filename = str_replace( "*",  "_", $filename );
	$filename = str_replace( "?",  "_", $filename );
	$filename = str_replace( "\"", "'", $filename );
	$filename = str_replace( "<",  "_", $filename );
	$filename = str_replace( ">",  "_", $filename );
	$filename = str_replace( "|",  "_", $filename );
*/
	// Faster solution?          xxxXXXxxxXXXxxxXx
	$filename = preg_replace( "/[\\\\\/\\*\\?\\|<>]/", "_", $filename );
	$filename = str_replace( ":",  "-", $filename );
	$filename = str_replace( "\"",  "'", $filename );
	return $filename;
}

// -----------------------------------------------------------------------------------------------------new_filename-----
function new_filename( $dir, $name, $ext )
{
	$i = 2;
	$sure = $dir . $name;
	$test = $sure . $ext;
	while(  file_exists( $test ) && ( $i < 100 ) )
	{
		$test = $sure . " " . sprintf( "%02u", $i++ ) . $ext;
	}
	return ( ( $i == 100 ) ? -1 : $test );
}

// -----------------------------------------------------------------------------------------------------cripple_html-----
function cripple_html( $text )
{
	$text = str_replace( "@", "<B STYLE=\"color:#FF0000;display:none\">--SPAMFIGHTER--</B>&#64", $text );
	return $text;
}

// -------------------------------------------------------------------------------------------------------cripple_js-----
function cripple_js( $text )
{
	$text = str_replace( "@", "\\x40", $text );
	return $text;
}

?>