<? /*
 * phpHartPOP - A simple web interface to a POP3 mailbox
 * Copyright (C) 2003 Sebastian Pipping
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * Sebastian Pipping <webmaster@hartwork.org>
 */

$socket = 0;

function get_answer()
{
	global $socket;
	return fgets( $socket, 1024 );
}

function pop3_top( $index, &$output_headers )
{
	global $socket;
	fputs( $socket, "TOP " . $index . " 0\015\012" );

	while( TRUE )
	{
		$line = get_answer();
		if( pop3_success( $line ) ) break;
	}

	$output_headers = "";
	while( TRUE )
	{
		$line = get_answer();
		if( substr( $line, 0, 1 ) == "." )
		{
			break;
		}
		else
		{
			$output_headers .= $line;
		}
	}
}

function pop3_retr( $index, &$output_headers )
{
	global $socket;
	fputs( $socket, "RETR " . $index . "\015\012" );

	while( TRUE )
	{
		$line = get_answer();
		if( pop3_success( $line ) ) break;
	}

	$output_headers = "";
	while( TRUE )
	{
		$line = get_answer();
		if( substr( $line, 0, 1 ) == "." )
		{
			break;
		}
		else
		{
			$output_headers .= $line;
		}
	}
}

function pop3_success( &$answer )
{
	return ( substr( $answer, 0, 1 ) == "+" );
}

function pop3_disconnect()
{
	global $socket;
	if( $socket )
	{
		fputs( $socket, "QUIT\015\012" );
		$line = get_answer();
		fclose( $socket );
	}
}

?>