<? /*
 * phpHartPOP - A simple web interface to a POP3 mailbox
 * Copyright (C) 2003 Sebastian Pipping
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * Sebastian Pipping <webmaster@hartwork.org>
 */

include( "config.php" );
include( "shared.gen.inc.php" );
include( "shared.mime.inc.php" );
include( "shared.pop3.inc.php" );

prevent_caching();

// Ensure we get the time we need
set_time_limit( 0 );

// Get account
$account = $_GET[ "account" ];
if( $account == "" )
{
	exit;
}

// Get index
$index = $_GET[ "index" ];
if( $index == "" )
{
	exit;
}

// Get action
$action = $_GET[ "action" ];
if( $action == "" )
{
	exit;
}

session_start();

// Check account settings
$account_host = $_SESSION[ $account . "host" ];
if( $account_host == "" )
{
	exit;
}
$account_port = $_SESSION[ $account . "port" ];
if( $account_port == "" )
{
	exit;
}
$account_user = $_SESSION[ $account . "user" ];
if( $account_user == "" )
{
	exit;
}
$account_pass = $_SESSION[ $account . "pass" ];
if( $account_pass == "" )
{
	exit;
}

// First header
header( "Content-type: text/plain" );

// Connect
$socket = @fsockopen( $account_host, $account_port, $errno, $errstr, CONNECTION_TIMEOUT );
if( !$socket )
{
	exit;
}
register_shutdown_function( "pop3_disconnect" );
$line = get_answer();
if( !pop3_success( $line ) )
{
	exit;
}

// USER
fputs( $socket, "USER " . $account_user . "\015\012" );
$line = get_answer();
if( !pop3_success( $line ) )
{
	exit;
}

// PASS
fputs( $socket, "PASS " . $account_pass . "\015\012" );
$line = get_answer();
if( !pop3_success( $line ) )
{
	exit;
}

// RETR
pop3_retr( $index, $content );
if( !strcasecmp( $action, "download" ) )
{
	get_from( $content, $from_name, $from_addy );
	get_subject( $content, $subject );
	get_date( $content, $date );

	// Second header
	$filename = valid_filename( "[$from_name] -- [$date] -- [$subject]" ) . ".eml";
	header( "Content-Disposition: attachment; filename=\"$filename\"" );
}
echo $content;

?>